QuantLib: MultiplicativePriceSeasonality Class Reference

A free/open-source library for quantitative finance Reference manual - version 1.6

- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
MultiplicativePriceSeasonality Class Reference

Multiplicative seasonality in the price index (CPI/RPI/HICP/etc). More...

`#include <ql/termstructures/inflation/seasonality.hpp>`

Inheritance diagram for MultiplicativePriceSeasonality:
[legend]

## Public Member Functions
| MultiplicativePriceSeasonality (const Date &seasonalityBaseDate, const Frequency frequency, const std::vector< Rate > seasonalityFactors)
virtual void | set (const Date &seasonalityBaseDate, const Frequency frequency, const std::vector< Rate > seasonalityFactors)
virtual Date | seasonalityBaseDate () const
| inspectors
virtual Frequency | frequency () const
virtual std::vector< Rate > | seasonalityFactors () const
virtual Rate | seasonalityFactor (const Date &d) const
| The factor returned is NOT normalized relative to ANYTHING.
Seasonality interface
virtual Rate | correctZeroRate (const Date &d, const Rate r, const InflationTermStructure &iTS) const
virtual Rate | correctYoYRate (const Date &d, const Rate r, const InflationTermStructure &iTS) const
virtual bool | isConsistent (const InflationTermStructure &iTS) const
Seasonality interface

## Protected Member Functions
virtual void | validate () const
virtual Rate | seasonalityCorrection (Rate r, const Date &d, const DayCounter &dc, const Date &curveBaseDate, bool isZeroRate) const

## Detailed Description

Multiplicative seasonality in the price index (CPI/RPI/HICP/etc).

Stationary multiplicative seasonality in CPI/RPI/HICP (i.e. in price) implies that zero inflation swap rates are affected, but that year-on-year inflation swap rates show no effect. Of course, if the seasonality in CPI/RPI/HICP is non-stationary then both swap rates will be affected.

Factors must be in multiples of the minimum required for one year, e.g. 12 for monthly, and these factors are reused for as long as is required, i.e. they wrap around. So, for example, if 24 factors are given this repeats every two years. True stationary seasonality can be obtained by giving the same number of factors as the frequency dictates e.g. 12 for monthly seasonality.

Warning:
  Multi-year seasonality (i.e. non-stationary) is fragile: the user must ensure that corrections at whole years before and after the inflation term structure base date are the same. Otherwise there can be an inconsistency with quoted rates. This is enforced if the frequency is lower than daily. This is not enforced for daily seasonality because this will always be inconsistent due to weekends, holidays, leap years, etc. If you use multi-year daily seasonality it is up to you to check.

Note
  Factors are normalized relative to their appropriate reference dates. For zero inflation this is the inflation curve true base date: since you have a fixing for that date the seasonality factor must be one. For YoY inflation the reference is always one year earlier.

Seasonality is treated as piecewise constant, hence it works correctly with uninterpolated indices if the seasonality correction factor frequency is the same as the index frequency (or less).

## Member Function Documentation

virtual bool isConsistent | ( | const InflationTermStructure & | iTS | ) | const
| virtual

It is possible for multi-year seasonalities to be inconsistent with the inflation term structure they are given to. This method enables testing - but programmers are not required to implement it. E.g. for price seasonality the corrections at whole years after the inflation curve base date should be the same or else there can be an inconsistency with quoted instruments. Alternatively, the seasonality can be set before the inflation curve is bootstrapped.

Reimplemented from Seasonality.